var CdSUtil = {
	sBranch: Components.classes["@mozilla.org/preferences-service;1"]
	                   .getService(Components.interfaces.nsIPrefBranch),

	sPreferencias: Components.classes["@mozilla.org/preferences-service;1"]
	                         .getService(Components.interfaces.nsIPrefService),

	mac: function() {return top.window.navigator.platform.toLowerCase().indexOf("mac") >= 0;},
	flock: function() {return top.window.navigator.userAgent.toLowerCase().indexOf("flock") >= 0;},
	iceape: function() {return top.window.navigator.userAgent.toLowerCase().indexOf("iceape") >= 0;},
	iceweasel: function() {return top.window.navigator.userAgent.toLowerCase().indexOf("iceweasel") >= 0;},
	netscape: function() {return top.window.navigator.userAgent.toLowerCase().indexOf("netscape") >= 0;},

	fx: function() {return this.firefox() || this.iceweasel() || this.flock() || this.netscape();},
	sm: function() {return this.seamonkey() || this.iceape();},

	firefox: function () {
		var release  = top.window.navigator.userAgent.toLowerCase().indexOf("firefox") >= 0;
		var nightly  = top.window.navigator.userAgent.toLowerCase().indexOf("minefield") >= 0;
		return (release || nightly) && !this.iceweasel() && !this.netscape() && !this.flock();
	},

	seamonkey: function () {
		var release = top.window.navigator.userAgent.toLowerCase().indexOf("seamonkey") >= 0;
		return release && !this.iceape();
	},

	abrirURL: function (url) {
		var janela = null;

		try {
			var sJanelas = Components.classes["@mozilla.org/appshell/window-mediator;1"]
			                         .getService(Components.interfaces.nsIWindowMediator);
			janela = sJanelas.getMostRecentWindow("navigator:browser");
		}
		catch(erro) {
			dump("** CdS error: couldn't get Window Mediator:\n"+erro+"\n\n");
		}

		if (janela) {
			janela.getBrowser().selectedTab = janela.getBrowser().addTab(url);
			janela.focus();
		}
		else
			openDialog(this.obterString("browser.chromeURL"), "_blank", "chrome,all,dialog=no", url, null, null);
	},

	existePreferencia: function (preferencia) {
		return this.sBranch.prefHasUserValue(preferencia);
	},

	limparPreferencia: function (preferencia) {
		if (this.existePreferencia(preferencia))
			try {
				this.sBranch.clearUserPref(preferencia);
				return true;
			}
			catch(erro) {
				dump("** CdS error: couldn't clear user pref \""+preferencia+"\"\n\n");
			}
		else
			dump("** CdS error: no user pref found for \""+preferencia+"\"\n\n");

		return false;
	},

	listaEstaVazia: function (lista) {
		if (lista[0])
			return false;

		return true;
	},

	obterBooleana: function (preferencia, valorPadrao) {
		try {
			return this.sBranch.getBoolPref(preferencia);
		}
		catch(erro) {
			dump("** CdS error: couldn't get bool pref \""+preferencia+"\"\n\n");
		}

		return valorPadrao != undefined ? valorPadrao : null;
	},

	obterInteiro: function (preferencia, valorPadrao) {
		try {
			return this.sBranch.getIntPref(preferencia);
		}
		catch(erro) {
			dump("** CdS error: couldn't get int pref \""+preferencia+"\"\n\n");
		}

		return valorPadrao != undefined ? valorPadrao : null;
	},

	obterPosicao: function (elemento, lista) {
		for (i in lista)
			if (lista[i] == elemento)
				return parseInt(i);

		return -1;
	},

	obterPosicaoPol: function (politica, lista) {
		for (i in lista)
			if (lista[i].nome == politica)
				return parseInt(i);

		return -1;
	},

	obterString: function (preferencia, valorPadrao) {
		try {
			return this.sBranch.getComplexValue(preferencia, Components.interfaces.nsISupportsString).data;
		}
		catch(erro) {
			dump("** CdS error: couldn't get string pref \""+preferencia+"\"\n\n");
		}

		return valorPadrao != undefined ? valorPadrao : null;
	},

	salvarBooleana: function (preferencia, valor) {
		try {
			this.sBranch.setBoolPref(preferencia, valor);
			return true;
		}
		catch(erro) {
			dump("** CdS error: couldn't set bool pref \""+preferencia+"\"\n\n");
		}

		return false;
	},

	salvarInteiro: function (preferencia, valor) {
		try {
			this.sBranch.setIntPref(preferencia, valor);
			return true;
		}
		catch(erro) {
			dump("** CdS error: couldn't set int pref \""+preferencia+"\"\n\n");
		}

		return false;
	},

	salvarString: function (preferencia, valor) {
		try {
			var str = Components.classes["@mozilla.org/supports-string;1"]
			                    .createInstance(Components.interfaces.nsISupportsString);
			str.data = valor;
			this.sBranch.setComplexValue(preferencia, Components.interfaces.nsISupportsString, str);
			return true;
		}
		catch(erro) {
			dump("** CdS error: couldn't set string pref \""+preferencia+"\"\n\n");
		}

		return false;
	}
}
